/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.wahl.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.wahl.entity.Wahlart;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractWahlartSearch {

  @Inject
  protected transient WahlartExtendedDAO dao;

  public AbstractWahlartSearch() {
    super();
  }

  public List<Wahlart> getSearchResult(WahlartSearchParameters searchParameters, EagerLoadingCollector<Wahlart> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Wahlart> querySearchResult(WahlartSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
